/*
 * @(#)%Name% %Version% %Time%
 * 
 * Copyright (c) 1997 Rutgers University
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that (i) the above copyright notice and this permission notice
 * appear in all copies of the software and related documentation. (ii) 
 * the name of Rutgers University may not be used in any advertising
 * or publicity relating to the software without the specific, prior
 * written permission of Rutgers University.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL RUTGERS UNIVERSITY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * CopyrightVersion %Version%
 * @author		%Author%
 * @version		%Version%, %Time%
 * @since		ACT %Version%
 *
 */

package EDU.rutgers.CORBA.GIOP.actions;

import EDU.rutgers.act.protocol.Message;
import EDU.rutgers.act.endpoint.Endpoint;

import EDU.rutgers.CORBA.GIOP.messages.*;

import EDU.rutgers.CORBA.IIOP.ProfileBody;
import EDU.rutgers.CORBA.IOP.IOR;

import EDU.rutgers.act.protocol.FSMAction;

public final class GIOPClientRequestAction implements FSMAction
{
  public int run(Message previous, Message current, Message[] next) {
        next[0] = null;
        if(current instanceof GIOPReplyMessage) {
            GIOPReplyMessage reply = (GIOPReplyMessage)current;
            switch (reply.reply_status_.value()) {
                case ReplyStatusType._LOCATION_FORWARD : {
	                if(previous instanceof GIOPRequestMessage) {
                        IOR ior = reply.getIOR();
                        if (ior == null) {
                            break;
                        }
                        ProfileBody profile = ior.getIIOPProfile();
                        if (profile == null) {
                            break;
                        }
                        Endpoint ep = new Endpoint(profile.host_, profile.port_);
                        GIOPRequestMessage request = (GIOPRequestMessage)previous;
                        request.setEndpoint(ep);
	                    next[0] = request;
	                    return GIOPAction.REQUEST;
	                }
                    break;
                }
                case ReplyStatusType._USER_EXCEPTION :
                case ReplyStatusType._SYSTEM_EXCEPTION : {
	                return FSMAction.ERROR;
                }
                case ReplyStatusType._NO_EXCEPTION : {
	                return FSMAction.EXIT;
                }
            }
        }
        return FSMAction.ERROR;
    }
}
