// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class BooleanCell extends BaseTypeSpecCell
{
  public BooleanCell()
    {
      type_ = T_BOOLEAN;
    }

  public void generate(int attr)
    {
      String type = ((attr == ParamDclCell.IN) ? "boolean" : "BooleanHolder");
      Generator.interfaceWriter_.print(type);
      Generator.staticStubWriter_.print(type);
      Generator.staticSkelWriter_.print(type);
    }

  public String toString()
    {
      return "boolean";
    }

  public String toString(int attr)
    {
      if(attr == ParamDclCell.IN)
	return "boolean";
      return "BooleanHolder";
    }

  public String initialValue()
    {
      return "false";
    }

  void genStubIn(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	"out.writeBoolean(" +
        str +
	");"
				);
    }

  void genStubOut(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	str +
	" = in.readBoolean();"
				);
    }

  void genSkelIn(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	str +
        " = in.readBoolean();");
    }

  void genSkelOut(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	"out.writeBoolean(" +
        str +
	");"
					  );
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("boolean");
    }
}
