// for emacs only: -*- C++ -*-

// last update: 11/18/1997

package EDU.rutgers.CORBA.idl.ir;

public class DefinedTypeCell extends ParamTypeSpecCell
{
  public ScopedNameCell name_; // name of the type
  public ParamTypeSpecCell realType_;

  public DefinedTypeCell(ScopedNameCell name)
    {
      type_ = T_DEFINED_TYPE;
      name_ = name;
      realType_ = null;
    }

  public void generate(int attr)
    {
      checkRealType();
      realType_.generate(attr);
    }

  public String toString()
    {
      checkRealType();
      return realType_.toString();
    }

  public String toString(int attr)
    {
      checkRealType();
      return realType_.toString(attr);
    }

  public String initialValue()
    {
      checkRealType();
      return realType_.initialValue();
    }

  void genStubIn(int indent, String str)
    {
      checkRealType();
      realType_.genStubIn(indent, str);
    }

  void genStubOut(int indent, String str)
    {
      checkRealType();
      realType_.genStubOut(indent, str);
    }

  void genSkelIn(int indent, String str)
    {
      checkRealType();
      realType_.genSkelIn(indent, str);
    }

  void genSkelOut(int indent, String str)
    {
      checkRealType();
      realType_.genSkelOut(indent, str);
    }

  void checkRealType()
    {
      if(realType_ == null)
	if((realType_ = (ParamTypeSpecCell)Generator.symTab_.get(
                        name_.toString())) == null)
	  {
	    System.err.println("error: type " + name_.toString() +
                               " used before defining it");
	    System.exit(1);
	  }
      if(realType_ instanceof SequenceCell)
	  ((SequenceCell)realType_).id_ = name_.ids_.lastId();
    }

  void freezeContext()
    {
      name_.toRoot();
      checkRealType();
      realType_.freezeContext();
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("USER DEFINED: " + name_.toString());
    }
}
