// for emacs only: -*- C++ -*-

// last update: 09/01/1997

package EDU.rutgers.CORBA.idl.ir;

public class InterfaceDclCell extends InterfaceXCell
{
  public InterfaceDclCell(InterfaceHeaderCell header,
			  SemicolonCell body)
    {
      type_ = T_INTERFACE_DCL;
      header_ = header;   // header
      body_ = body;       // body
    }
  
  public void generate(int indent) throws java.io.IOException
    {
      // header
      header_.generate(0);

      //
      // body
      //
      Generator.interfaceWriter_.println("{");
      body_.generate(2);
      Generator.interfaceWriter_.println("}");

      //
      // body of static skeleton
      //
      Generator.staticSkelWriter_.println(
	"  protected void callMethod(String operation,");
      Generator.staticSkelWriter_.println(
	"                            TypeReader in,");
      Generator.staticSkelWriter_.println(
	"                            TypeWriter out)");
      Generator.staticSkelWriter_.println(
	"    {");

      // operations
      // to be improved, right now it is quite inefficient
      //   if the CORBA object has methods with the same long prefix
      //   example: activateObject and activateObjectWithId
      if(body_ != null)
	{
	  body_.genSkelOps(6);
	}

      //
      // _is_a operation
      //
      /*
      int indent = 6;
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
        "if(operation.compareTo(\"" +
        "_is_a" +
        "\") == 0)");

      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("  {");
      
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("     " +
					  "_is_a" +
					  "Invoke(in, out);");

      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("  }");
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("else");
      */
      //
      // end of _is_a operation
      //

      Generator.staticSkelWriter_.println(
	"        { // the operation does not match any operation in this object!");
      Generator.staticSkelWriter_.println(
	"          // send an exception here, but not implemented yet");
      Generator.staticSkelWriter_.println(
	"          System.out.println(\"Unknown operation!\");");
      Generator.staticSkelWriter_.println(
	"        }");

      Generator.staticSkelWriter_.println(
	"    }");
      //
      // end interface
      //
      Generator.interfaceWriter_.close();
      Generator.staticStubWriter_.print("}");
      Generator.staticSkelWriter_.print("}");
      Generator.staticStubWriter_.close();
      Generator.staticSkelWriter_.close();
    }


  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("INTERFACE_DCL_CELL:");
      if(header_ != null)
	header_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      

      if(body_ != null)
	body_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      
    }

  // data members

  InterfaceHeaderCell header_;
  SemicolonCell body_;
}
