// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class ParameterDclsCell extends Cell
{
  // data members

  public ParamDclCell decl_;
  public ParameterDclsCell paramList_;

  // constructors

  public ParameterDclsCell(ParamDclCell left, ParameterDclsCell right)
    {
      type_ = T_PARAMETER_DCLS;
      decl_ = left;
      paramList_ = right;
    }

  public void generate(int indent) throws java.io.IOException
    {
      decl_.generate(indent);
      if(paramList_ != null)
	{
	  Generator.interfaceWriter_.println(",");
	  Generator.staticStubWriter_.println(",");
	  Generator.staticSkelWriter_.println(",");
	  paramList_.generate(indent);
	}
      else
	{
	  Generator.interfaceWriter_.println();
	  Generator.staticStubWriter_.println();
	  Generator.staticSkelWriter_.println();
	}
    }

  void genStubArg(int indent, String str)
    {
      decl_.genStubArg(indent, str);
      if(paramList_ != null)
	paramList_.genStubArg(indent, str);
    }

  void genStubIn(int indent, String str)
    {
      decl_.genStubIn(indent, str);
      if(paramList_ != null)
	paramList_.genStubIn(indent, str);
    }

  void genStubOut(int indent, String str)
    {
      decl_.genStubOut(indent, str);
      if(paramList_ != null)
	paramList_.genStubOut(indent, str);
    }

  void genSkelArg(int indent, String str)
    {
      decl_.genSkelArg(indent, str);
      if(paramList_ != null)
	paramList_.genSkelArg(indent, str);
    }

  void genSkelIn(int indent, String str)
    {
      decl_.genSkelIn(indent, str);
      if(paramList_ != null)
	paramList_.genSkelIn(indent, str);
    }

  void genSkelOut(int indent, String str)
    {
      decl_.genSkelOut(indent, str);
      if(paramList_ != null)
	paramList_.genSkelOut(indent, str);
    }

  public String toString()
    {
      String prefix = decl_.id_;
      
      if(paramList_ == null)
	{
	  return prefix;
	}
      return prefix + ", " + paramList_.toString();
    }
  



  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("PARAMETER_DCLS:");
      if(decl_ != null)
	decl_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      

      if(paramList_ != null)
	paramList_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      
    }
}
