// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class SemicolonCell extends Cell
{
  // data members

  public ExportCell export_;
  public SemicolonCell semicolon_;

  // constructors

  public SemicolonCell(ExportCell export, 
		       SemicolonCell semicolon)
    {
      type_ = T_SEMICOLON;
      export_ = export;       // operation decl or typedef, etc
      semicolon_ = semicolon; // the rest of the decls
    }

  public void generate(int indent) throws java.io.IOException
    {
      export_.generate(indent);
      if(semicolon_ != null) semicolon_.generate(indent);
    }

  public void genSkelOps(int indent)
    {
      if(export_.type_ == Cell.T_OP_DECL)
	((OpDclCell)export_).genSkelOps(indent);
      if(semicolon_ != null)
	{
	  semicolon_.genSkelOps(indent);
	}
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("SEMICOLON:");
      if(export_ != null)
	export_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      

      if(semicolon_ != null)
	semicolon_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      
    }
}
