// for emacs only: -*- C++ -*-

// last update: 01/12/1998

package EDU.rutgers.CORBA.idl.ir;

public class StructCell extends TypeDclCell
{
  public StructCell(String id,
		    MemberList memberList)
    {
      type_ = T_STRUCT_DCL;
      id_ = id;                 // the structure's name
      memberList_ = memberList; // types and names of members
    }
  
  public void generate(int indent) throws java.io.IOException
    {
      // first define the type <interface name>
      String key = Generator.packTrack_.toString();
      key = (key == null) ? id_ : key + "." + id_;
      ParamTypeSpecCell realType  = new StructTypeCell(key, memberList_);
      // System.err.println("Adding type " + key);
      Generator.symTab_.put(key, realType);

      //
      // class
      //
      java.io.PrintWriter classWriter;

      classWriter = 
	new java.io.PrintWriter(
	  Generator.fileFactory_.create(id_ + ".java"));

      classWriter.println(
	"package " + Generator.packTrack_.toString() +
         ";\n\n");
      classWriter.println(
	"import ORG.omg.CORBA.*;\n");
      classWriter.println(
		    "public final class " + id_ + "\n{\n");

      // Time to generate the fields and the two constructors
      MemberList current;
      for(current = memberList_;
	  current != null;
	  current = current.next_)
	{
	  classWriter.println(
		   "  public " + current.memberType_.toString() +
		   " " + current.id_ + ";");
	}

      classWriter.println("  public " + id_ + "() {}");
      classWriter.println("  public " + id_ + "(");
      
      for(current = memberList_;
	  current.next_ != null;
	  current = current.next_)
	{
	  classWriter.println(
		"    " + current.memberType_ + " " + current.id_ + "_,");
	}
      classWriter.println(
	"    " + current.memberType_ + " " + current.id_ + "_");

      classWriter.println("  )");
      classWriter.println("  {");
      for(current = memberList_;
	  current != null;
	  current = current.next_)
	{
	  classWriter.println(
		"    " +  current.id_ + " = " + current.id_ + "_;");
	}
      classWriter.println("  }");

      classWriter.println("}");
      classWriter.close();
      

      //
      // holder
      //
      java.io.PrintWriter holder =
	new java.io.PrintWriter(
	  Generator.fileFactory_.create(id_ + "Holder.java"));
      holder.println(
	"package " + Generator.packTrack_.toString() +
         ";\n\n");
      holder.println("final public class " + id_ + "Holder");
      holder.println("{");
      holder.println("  public " + id_ + 
		     " value;");
      holder.println("  public " + id_ + 
		     "Holder() {}");
      holder.println("  public " + id_ + 
		     "Holder(" + id_ + " initial) {");
      holder.println("    value = initial;");
      holder.println("  }");
      holder.println("}");
      holder.close();


    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.print("STRUCT_DCL_CELL: ");

      System.out.println(id_ == null ? "null" : id_);

      if(memberList_ != null)
	memberList_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      
    }

  // data members
  String id_;
  MemberList memberList_;
}
