// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class UnsignedShortCell extends UnsignedIntCell
{
  public UnsignedShortCell()
    {
      type_ = T_UNSIGNED_SHORT;
    }

  public void generate(int attr)
    {
      String type = ((attr == ParamDclCell.IN) ? "short" : "ShortHolder");
      Generator.interfaceWriter_.print(type);
      Generator.staticStubWriter_.print(type);
      Generator.staticSkelWriter_.print(type);
    }

  public String toString()
    {
      return "short";
    }

  public String toString(int attr)
    {
      if(attr == ParamDclCell.IN)
	return "short";
      return "ShortHolder";
    }

  public String initialValue()
    {
      return "0";
    }

  void genStubIn(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	"out.writeUShort(" +
        str +
	");"
				);
    }

  void genStubOut(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	str +
	" = in.readUShort();"
				);
    }

  void genSkelIn(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	str +
        " = in.readUShort();");
    }

  void genSkelOut(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	"out.writeUShort(" +
        str +
	");"
					  );
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("unsigned short");
    }
}
