// for emacs: -*- C++ -*-

// last update: 07/28/97

package EDU.rutgers.act.clntsrv.threadengine;

import EDU.rutgers.act.protocol.*;
/**
 * This class handles one request message.  If
 * method handleRequest is called from two
 * threads it serializes the calls.  Handling
 * of requests means passing them to a Service
 * object (Object Adaptor).
 */
class RequestHandler implements Runnable
{ 
  Service service_;
  Message message_;
  Sender sender_;

  public RequestHandler(Service s) 
    {
      service_ = s;
      message_ = null;
      sender_ = null;
    }

  public RequestHandler(Service s, Message m, Sender sender)
    {
      service_ = s;
      message_ = m;
      sender_ = sender;
    }
  

  // public methods
  public void setMessageAndSender(Message m, Sender sender)
    {
      message_ = m;
      sender_ = sender;
    }


  public synchronized void run() 
    {
      service_.handleRequest(message_, sender_);
    }
}
