// for emacs: -*- C++ -*-

// last update: 07/28/97

package EDU.rutgers.act.clntsrv.threadengine;

import EDU.rutgers.act.protocol.*;

/**
 * This class creates a RequestHandler object and
 * returns it. It is responsible with the
 * multi-threading policy (non-threaded, TpR,
 * TpS, PoT). For mono-threaded servers it
 * will return the same RequestHandler object,
 * such that requests will be serialized.
 * For Thread-per-Session servers it will
 * return the same RequestHandler for one
 * connection. For Thread-per Request, it will
 * create a new RequestHandler every time.
 * For Pool-of-Threads it will
 * pre-spawn initially n threads, and every
 * time a request comes it will choose
 * the next available thread and then return
 * the RequestHandler object running in that thread.
 */
public interface RequestHandlerFactory { 
  public void createRequestHandler(Message request,
				   Sender serverSender);
}
