package EDU.rutgers.act.protocol.mcast;

import java.net.*;
import java.io.*;

import EDU.rutgers.util.Verbose;
import EDU.rutgers.act.presentation.*;
import EDU.rutgers.act.protocol.*;

public class ProtocolServer implements Server
{
  protected MessageFactory messageFactory_;
  protected TransferSyntaxFactory tsf_;
  protected ClientSender cs_;
  
  public ProtocolServer(MessageFactory messageFactory,
			TransferSyntaxFactory dataTsf_,
			ClientSender cs)
        throws IOException
    {
      messageFactory_ = messageFactory;
      tsf_ = dataTsf_;
      cs_ = cs;
    }


  public synchronized Protocol accept() throws java.io.IOException
    {
      InputStream is = cs_.accept();
      TypeReader tr = tsf_.createTypeReader(
	new BufferedInputStream(is));
      ServerReceiver sr = new ServerReceiver(tr, messageFactory_);

      return new Protocol(sr, null);
    }

  public short getPort()
    {
      return 0;
    }
}
