// last modified 5/25/98

package EDU.rutgers.cbus.clntsrv;

import EDU.rutgers.act.protocol.*;
import EDU.rutgers.act.clntsrv.threadengine.Service;
import EDU.rutgers.cbus.protocol.messages.CBusEvent;

class OA implements Service
{
  protected final static int MAX_SERVANTS = 5000;
  protected Servant[] array_;
  protected int size_;
  protected String host_; // local host
  protected short port_;  // local port

  public OA()
    {
      array_ = new Servant[MAX_SERVANTS];
      size_ = 0;
    }

  public Servant get(int objKey)
    {
      return array_[objKey];
    }
  
  public int put(Servant servant)
    {
      int retVal;
      array_[retVal = size_++] = servant;
      return retVal;
    }

  public void setLocalAddress(String host, short port)
    {
      host_ = host;
      port_ = port;
    }
  
  public void handleRequest(Message m, Sender s)
    {
      CBusEvent event = (CBusEvent)m;
      Servant servant = get(event.getObjKey());
      servant.dispatchEventLocally(event);
    }
}
