package EDU.rutgers.cbus.presentation;

import java.io.Serializable;
import java.util.EventListener;
import java.util.Vector;

import EDU.rutgers.cbus.protocol.messages.CBusEvent;
import EDU.rutgers.cbus.protocol.messages.CBusEventListener;

public class CBusSource implements Serializable
{
  protected Vector cbusListeners_;

  public CBusSource()
    {
      cbusListeners_ = new Vector();
    }
  
 /*******************************************************
  * Source of CBusEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public synchronized void addCBusEventListener(CBusEventListener l)
    {
      cbusListeners_.addElement(l);
    }

  public synchronized void removeCBusEventListener(CBusEventListener l)
    {
      cbusListeners_.removeElement(l);
    }

  public void fireCBusEvent(CBusEvent event)
    {
      Vector targets;
      synchronized (this)
	{
	  targets = (Vector) cbusListeners_.clone();
	}

      for (int i = 0; i < targets.size(); i++)
	{
	  CBusEventListener target = (CBusEventListener)targets.elementAt(i);
	  target.processCBusEvent(event);
	}
    }
}
