package EDU.rutgers.cbus.presentation;

import java.io.IOException;

import EDU.rutgers.cbus.protocol.messages.CBusEvent;
import EDU.rutgers.cbus.protocol.messages.CBusEventListener;
import EDU.rutgers.cbus.clntsrv.Communicator;
import EDU.rutgers.cbus.clntsrv.Servant;

public class EventReplicator
  extends CBusSource
  implements CBusEventListener, Servant
{
  protected transient Communicator comm_;
  protected transient int myObjKey_;

  public EventReplicator(Communicator comm)
    {
      comm_ = comm;
      register();
    }

  protected void register()
    {
      myObjKey_ = comm_.connect(this);
    }

  private void readObject(java.io.ObjectInputStream in)
    throws IOException, ClassNotFoundException
    {
      in.defaultReadObject();
      register();
    }

 /*******************************************************
  * The EventReplicator is a listener of CBusEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public void processCBusEvent(CBusEvent event)
    {
      event.setObjKey(myObjKey_);
      comm_.replicateEvent(event);
    }

 /*******************************************************
  * This method gets called byt the communicator.
  *******************************************************/
  public void dispatchEventLocally(CBusEvent event)
    {
      fireCBusEvent(event);
    }
}
