package EDU.rutgers.cbus.presentation;

import java.util.EventObject;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.Component;

public class KeyAdaptor extends EventAdaptor implements KeyListener
{
  public KeyAdaptor(Component component)
    {
      super(component);
    }
  
 /*******************************************************
  * The KeyAdaptor is a source of KeyEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public synchronized void addKeyListener(KeyListener l)
    {
      eventListeners_.addElement(l);
    }
  
  public synchronized void removeKeyListener(KeyListener l)
    {
      eventListeners_.removeElement(l);
    }

  protected void invoke(Object target, EventObject event)
    {
      KeyEvent me = (KeyEvent)event;
      KeyListener ml = (KeyListener) target;

      switch(me.getID())
	{
	case KeyEvent.KEY_PRESSED:
	  ml.keyPressed(me);
	  break;
	case KeyEvent.KEY_RELEASED:
	  ml.keyReleased(me);
	  break;
	case KeyEvent.KEY_TYPED :
	  ml.keyTyped(me);
	  break;
	default:
	  System.out.println("@KeyAdaptor.invoke(): illegal KeyEvent type");
	}
    }
 /*******************************************************
  * The KeyAdaptor is a listener of KeyEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public void keyPressed(KeyEvent e)
    {
      this.processEvent(e);
    }
  
  public void keyReleased(KeyEvent e)
    {
      this.processEvent(e);
    }
  
  public void keyTyped(KeyEvent e)
    {
      this.processEvent(e);
    }
}
