package EDU.rutgers.cbus.presentation;

import java.util.EventObject;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.Component;

public class MouseAdaptor extends EventAdaptor implements MouseListener
{
  public MouseAdaptor(Component component)
    {
      super(component);
    }
  
 /*******************************************************
  * The MouseAdaptor is a source of MouseEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public synchronized void addMouseListener(MouseListener l)
    {
      eventListeners_.addElement(l);
    }
  
  public synchronized void removeMouseListener(MouseListener l)
    {
      eventListeners_.removeElement(l);
    }

  protected void invoke(Object target, EventObject event)
    {
      MouseEvent me = (MouseEvent)event;
      MouseListener ml = (MouseListener) target;

      switch(me.getID())
	{
	case MouseEvent.MOUSE_CLICKED :
	  ml.mouseClicked(me);
	  break;
	case MouseEvent.MOUSE_ENTERED:
	  ml.mouseEntered(me);
	  break;
	case MouseEvent.MOUSE_EXITED:
	  ml.mouseExited(me);
	  break;
	case MouseEvent.MOUSE_PRESSED:
	  ml.mousePressed(me);
	  break;
	case MouseEvent.MOUSE_RELEASED:
	  ml.mouseReleased(me);
	  break;
	default:
	  System.out.println("@MouseAdaptor.invoke(): illegal MouseEvent type");
	}
    }
 /*******************************************************
  * The MouseAdaptor is a listener of MouseEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public void mouseClicked(MouseEvent e)
    {
      this.processEvent(e);
    }
  
  public void mousePressed(MouseEvent e)
    {
      this.processEvent(e);
    }
  
  public void mouseReleased(MouseEvent e)
    {
      this.processEvent(e);
    }
  
  public void mouseEntered(MouseEvent e)
    {
      this.processEvent(e);
    }
  
  public void mouseExited(MouseEvent e)  
    {
      this.processEvent(e);
    }
}
