package EDU.rutgers.cbus.presentation;

import java.awt.*;
import java.awt.event.*;

import EDU.rutgers.cbus.clntsrv.Communicator;

public class SimpleConnector extends Panel
{
  protected final static int TFX = 100, TFY = 30;
  protected final static int BX = 50, BY = 30;
  protected final static int SP = 5;
  protected Communicator comm_;

  public SimpleConnector(Communicator comm)
    {
      super(null);

      comm_ = comm;
      setSize(SP + TFX + SP + TFX + SP + TFX + SP, SP + 5*(TFY + SP));
      setBackground(Color.lightGray);

      Label l1 = new Label("Host");
      Label l2 = new Label("Port");
      Label l3 = new Label("Local Port");
      Label l4 = new Label("Log File");
      Label l5 = new Label("Delay * ms");

      TextField tf1 = new TextField(20);
      TextField tf2 = new TextField(20);
      TextField tf3 = new TextField(20);
      TextField tf4 = new TextField(20);
      TextField tf5 = new TextField(20);

      Button b1 = new Button("Connect");
      Button b2 = new Button("Start");
      Button b3 = new Button("Start Logging");
      Button b4 = new Button("Start Playing");
      
      add(l1);
      add(l2);
      add(l3);
      add(l4);
      add(l5);
      add(tf1);
      add(tf2);
      add(tf3);
      add(tf4);
      add(tf5);
      add(b1);
      add(b2);
      add(b3);
      add(b4);

      tf1.setSize(TFX, TFY);
      tf2.setSize(TFX, TFY);
      tf3.setSize(TFX, TFY);
      tf4.setSize(TFX, TFY);
      tf5.setSize(TFX, TFY);

      l1.setSize(TFX, TFY);
      l2.setSize(TFX, TFY);
      l3.setSize(TFX, TFY);
      l4.setSize(TFX, TFY);
      l5.setSize(TFX, TFY);

      b1.setSize(BX, BY);
      b2.setSize(BX, BY);
      b3.setSize(2*BX, BY);
      b4.setSize(2*BX, BY);

      l1.setLocation(SP, SP);
      tf1.setLocation(SP, SP + TFY + SP);
      l2.setLocation(SP, SP + 2*(TFY + SP));
      tf2.setLocation(SP, SP + 3*(TFY + SP));
      b1.setLocation(SP, SP + 4*(TFY + SP));

      b3.setLocation(SP + TFX + SP, SP + TFY + SP);
      l3.setLocation(SP + TFX + SP, SP + 2*(TFY + SP));
      tf3.setLocation(SP + TFX + SP, SP + 3*(TFY + SP));
      b2.setLocation(SP + TFX + SP, SP + 4*(TFY + SP));
      
      l4.setLocation(SP + 2*(TFX + SP) , SP + 0*(TFY + SP));
      tf4.setLocation(SP + 2*(TFX + SP), SP + 1*(TFY + SP));
      l5.setLocation(SP + 2*(TFX + SP) , SP + 2*(TFY + SP));
      tf5.setLocation(SP + 2*(TFX + SP), SP + 3*(TFY + SP));
      b4.setLocation(SP + 2*(TFX + SP) , SP + 4*(TFY + SP));


      B1ActionListener b1al = new B1ActionListener(tf1, tf2, comm_);
      b1.addActionListener(b1al);

      B2ActionListener b2al = new B2ActionListener(tf3, comm_);
      b2.addActionListener(b2al);

      B3ActionListener b3al = new B3ActionListener(b3, tf4, comm_);
      b3.addActionListener(b3al);

      B4ActionListener b4al = new B4ActionListener(b4, tf4, tf5, comm_);
      b4.addActionListener(b4al);

      setVisible(true);
    }

  public static void main(String[] args)
    {
      SimpleConnector f = new SimpleConnector(null);
      Frame win = new Frame("Simple Connector");
      win.setLayout(null);
      win.setSize(50 + SP + TFX + SP + TFX + SP, 50 + SP + 5*(TFY + SP));
      win.add(f);
      f.setLocation(15,30);
      
      win.setVisible(true);
    }
}
