// for emacs only: -*- C++ -*-

// last modified 02/12/98

package EDU.rutgers.naming;

import java.io.*;         // input/output
import ORG.omg.CORBA.*;   // holder classes

import EDU.rutgers.CORBA.clntsrv.PortableServer.*; // ORB, POA, etc
import EDU.rutgers.CORBA.clntsrv.PortableServer.POAPackage.*; // exceptions
import EDU.rutgers.bootstrap._InitialReferencesImpl;

class TransientNameServer
{
  public static void main(String[] args) throws 
    IOException,
    ObjectNotActive,
    WrongPolicy
    {
      // initialize the ORB
      ORB orb = ORB.init(args, null);

      POA poa = orb.POA_init();

      // create Naming Service implementation
      _NamingContextImpl srv = new _NamingContextImpl();

      // register implementation
      byte[] oid = poa.activate_object(srv);

      // create the object reference for this server object (myself)
      ORG.omg.CORBA.Object srvRef = poa.id_to_reference(oid);
      String srvStrIOR = orb.object_to_string(srvRef);
      
      // print the reference such that it can be used to
      // access the naming service without the bootstrap protocol, if needed
      System.out.println("Setup Naming Service with reference:");
      System.out.println(srvStrIOR);

      //
      // now initialize the InitialReferences object used
      // for obtaining the reference of the naming service
      //

      // create Naming Service implementation
      _InitialReferencesImpl ir = new _InitialReferencesImpl(srvRef);

      // register implementation
      poa.activate_object_with_id("INIT".getBytes(), ir);
    }
}
