// Source file: EDU/rutgers/util/ClosingFrame.java
// Subsystem: util
// Module: ClosingFrame

package EDU.rutgers.util;

import java.awt.Frame;
import java.awt.event.*;

public abstract class ClosingFrame extends Frame implements WindowListener
{
    public ClosingFrame()
    {
        super();
        addWindowListener(this);
    }
    
    protected abstract void frameClosing();
  
	public void windowClosing(WindowEvent we) 
	{
		frameClosing();
	}

	/** 
	   Necessary to implement interface <code>WindowListener</code>. 
	   All these functions do nothing.
	*/ 
	public void windowOpened(WindowEvent we) 
	{}
		
	public void windowClosed(WindowEvent we)
	{}
		
	public void windowIconified(WindowEvent we)
	{}

	public void windowDeiconified(WindowEvent we)
	{}

	public void windowActivated(WindowEvent we)
	{}

	public void windowDeactivated(WindowEvent we)
	{}
}