// Source file: EDU/rutgers/util/MessageBox.java
// Subsystem: util
// Module: MessageBox

package EDU.rutgers.util;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import EDU.rutgers.util.ClosingDialog;

public class MessageBox extends ClosingDialog
    implements ActionListener, Runnable
{	
    public MessageBox(Frame owner, String title, boolean modal, String msg)
    {
	    super(owner);
	    setTitle(title);
	    setModal(modal);
	    
        setBackground(Color.lightGray);

	    Label lblMsg = new Label(msg);
	    add("Center", lblMsg);

	    Button btnOK = new Button("OK");

	    Panel pnl = new Panel(new FlowLayout());   
	    pnl.add(btnOK);
	    add("South", pnl);

	    pack();
	
	    // add listener
		btnOK.addActionListener(this);
	
	    // start in a new thread so that it does not block the
	    // thread in which it was created
	    Thread t = new Thread(this);
	    t.start();
	}
	
	public void run()
	{
	    setVisible(true);
	}
    
    public void actionPerformed(ActionEvent ae)
	{
        setVisible(false);
		dispose();
	}

    protected void dialogClosing()
    {
        actionPerformed(null);
    }
}
