package EDU.rutgers.util;

public class Verbose
{
  public static final int OBJ_LEN = 19;
  public static final int MET_LEN = 14;
  public static final int MSG_LEN = 45;
  
  public static final byte[] dots = "...............................................................................".getBytes();
  public static final String blanks = new String("                                                                              ".getBytes(), 0, OBJ_LEN + MET_LEN + 2);
  public static /* final */ boolean verbose = false;

  public static void print(String object, String method, String msg1)
    {
      String msg2 = "", msg3 = "";
      
      if(object.length() > OBJ_LEN)
	{
	  object = new String(object.getBytes(), 0, OBJ_LEN);
	}
      
      if(method.length() > MET_LEN)
	{
	  method = new String(method.getBytes(), 0, MET_LEN);
	}
      
      if(msg1.length() > MSG_LEN)
	{
	  msg2 = new String(msg1.getBytes(), MSG_LEN, msg1.length() - MSG_LEN);
	  msg1 = new String(msg1.getBytes(), 0, MSG_LEN) + "\n" + blanks;

	  if(msg2.length() > MSG_LEN)
	    {
	      msg3 = new String(msg2.getBytes(), 
				MSG_LEN, msg2.length() - MSG_LEN);
	      msg2 = new String(msg2.getBytes(), 0, MSG_LEN) + "\n" + blanks;

	      if(msg3.length() > MSG_LEN)
		{
		  msg3 = new String(msg3.getBytes(), 0, MSG_LEN);
		}
	    }
	}
      
      System.out.println(object + 
			 new String(dots, 0, OBJ_LEN - object.length()) + 
			 " " + 
			 method + 
			 new String(dots, 0, MET_LEN - method.length()) + 
			 " " + msg1 + msg2 + msg3);
    }
}
