/*
 * @(#)%Name% %Version% %Time%
 * 
 * Copyright (c) 1997 Rutgers University
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that (i) the above copyright notice and this permission notice
 * appear in all copies of the software and related documentation. (ii) 
 * the name of Rutgers University may not be used in any advertising
 * or publicity relating to the software without the specific, prior
 * written permission of Rutgers University.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL RUTGERS UNIVERSITY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * CopyrightVersion %Version%
 * @author		%Author%
 * @version		%Version%, %Time%
 * @since		ACT %Version%
 *
 */

package ORG.omg.CORBA;

public abstract class TypeCode
{
    // for all TypeCode kinds
    public abstract boolean equal(TypeCode tc);
    public abstract TCKind kind();

    // for objref, struct, union, enum, alias and except
    public abstract String id() 
        throws BadKind;
    public abstract String name() 
        throws BadKind;

    // for struct, union, enum and except
    public abstract int member_count() 
        throws BadKind;
    public abstract String member_name(int index) 
        throws BadKind, Bounds;

    // for struct, union and except
    public abstract TypeCode member_type(int index) 
        throws BadKind, Bounds;

    // for union
    public abstract Any member_label(int index) 
        throws BadKind, Bounds;
    public abstract TypeCode discriminator_type() 
        throws BadKind;
    public abstract int default_index() 
        throws BadKind;

    // for string, sequence and array
    public abstract int length() 
        throws BadKind;
    public abstract TypeCode content_type() 
        throws BadKind;
}
