// for emacs only: -*- C++ -*-

// last modified 12/18/97

package examples.ACTMUD;

import java.io.IOException;
import java.io.InputStream;

public class NonblockingInputStream extends InputStream
{
  //
  // the original input stream
  //
  protected InputStream in_;

  //
  // constructors
  //
  public NonblockingInputStream()
    {
      in_ = System.in;
    }
  
  public NonblockingInputStream(InputStream in)
    {
      in_ = in;
    }
  
  //
  // methods
  //
  public int read() throws IOException
    {
      this.yield();
      return in_.read();
    }
  
  public int read(byte[] b) throws IOException
    {
      this.yield();
      return in_.read(b);
    }

  public int available() throws IOException
    {
      return in_.available();
    }
  
  //
  // Ugly hack, needed in Sun/Solaris JDK1.1 in order to
  // allow other threads to run while the current thread
  // calls "read" method upon some InputStream
  //
  protected void yield() throws IOException
    {
      while(in_.available() <= 0)
	Thread.yield();
    }
}
