// -*- C++ -*- (for emacs only)

package examples.Chat;

//imports

import java.util.Vector;
import java.awt.*;
import java.awt.event.*;

public class Chat extends Panel implements ActionListener {
  
  //constants
  public final static int  BX = 100, BY = 30;
  public final static int  X = 10, Y = 10;
  
  Chat panel;

  //labels
  Label welcomeLabel = new Label("Welcome to CBUS Chat Room");
  Label nameLabel = new Label("Choose a nickname");
  Label mesLabel1 = new Label("Type message below then press 'Send message' button:");
  Label mesLabel2 = new Label("Or press <ENTER>"); 
  
  //buttons 
  Button b1 = new Button("Login");
  Button b2 = new Button("Exit");
  Button b3 = new Button("Send message");
  Button b5 = new Button("Logout");
  
  //strings
  String nickname;
    
  //textareas
  TextField nicknameField = new TextField(); //field where the user types his
                                             //nickname
  TextArea t1 = new TextArea("Messages field"); //field where messages from all
                                                //users are displayed
  TextField typeMessagesField = new TextField();//field where every user types
  
  //panels
  Panel f1, f2;
  
  protected Vector listeners_;
  
  public Chat()
    {      
      listeners_ = new Vector();
      panel = this;
      
      this.setLayout(null);
      this.setSize(480, 380);
      
      this.addActionListener(this);


      //create two panels
      f1 = new Panel();    
      f2 = new Panel();
      
      f1.setLayout(null);
      f2.setLayout(null);
      
      f1.setSize(325, 200);
      f1.setBackground(Color.lightGray);
      
      //add components to f1
      f1.add(welcomeLabel);
      welcomeLabel.setSize(200, 40);
      welcomeLabel.setLocation(X, Y);
      
      f1.add(nameLabel);
      nameLabel.setLocation(X, Y+40);
      nameLabel.setSize(140, 20);
      
      f1.add(nicknameField);
      nicknameField.setLocation(X, 80+Y);
      nicknameField.setSize(300, 30);
           
      f1.add(b1);
      b1.setLocation(X, 140+Y);
      b1.setSize(BX, BY);
      
      f1.add(b2);
      b2.setLocation(X+BX+5, 140+Y);
      b2.setSize(BX, BY);     
 
      //capture buttons events 
      b1.addActionListener(new B1());
      b2.addActionListener(new B2());

      f1.setVisible(true);
           
      //f2 description
      f2.setSize(500, 400);
      f2.setBackground(Color.lightGray);
      
      //add components to f2
      t1.setEditable(false);
      t1.setBackground(new Color(200, 180, 180));
      f2.add(t1);
      t1.setLocation(X, Y+10);
      t1.setSize(470, 200);
      
      f2.add(b3);
      b3.setLocation(X, Y+220);
      b3.setSize(BX, BY);
      
      f2.add(b5);
      b5.setLocation(X+320, Y+220);
      b5.setSize(BX, BY);

      f2.add(mesLabel1);
      mesLabel1.setLocation(X, Y+270);
      mesLabel1.setSize(400, 20);

      f2.add(mesLabel2);
      mesLabel2.setLocation(X, Y+285);
      mesLabel2.setSize(200, 20);

      f2.add(typeMessagesField);
      typeMessagesField.setLocation(X, Y+320);
      typeMessagesField.setSize(470, 30);
      
      //capture events
      b3.addActionListener(new B6());
      typeMessagesField.addActionListener(new B3());     
      b5.addActionListener(new B5());


      //set panel f2 invisible; the panel will be visible only when
      //the user press Login
      f2.setVisible(false);

      //group the two panels in a single panel
      this.add(f1);
      this.add(f2);
      f1.setLocation(0, 0);
      f2.setLocation(0, 0);
      
      //visualize the big panel
      this.setVisible(true);      
    }
 
  public void actionPerformed(ActionEvent e)
    {
      t1.append(e.getActionCommand());
      t1.setCaretPosition(1000000);
      typeMessagesField.setText(""); 
    }

  public synchronized void addActionListener(ActionListener l)
    {
      listeners_.addElement(l);
    }

  public synchronized void removeActionListener(ActionListener l)
    {
      listeners_.removeElement(l);
    }

  public void fireActionEvent(ActionEvent event)
    {
      Vector targets;
      synchronized (this)
	{
	  targets = (Vector) listeners_.clone();
	}

      for (int i = 0; i < targets.size(); i++)
	{
	  ActionListener target = (ActionListener)targets.elementAt(i);
	  target.actionPerformed(event);
	}
    }
  

  class B1 implements ActionListener 
    {
      public void actionPerformed(ActionEvent e) 
      {
	nickname = nicknameField.getText();
	f2.setVisible(true);
	f1.setVisible(false);
      }
    }
  
  class B2 implements ActionListener
    {
      public void actionPerformed(ActionEvent e)
      {
	System.exit(0);
      }
    }
  
  class B3 implements ActionListener
    {
      public void actionPerformed(ActionEvent e)
	{
	  panel.fireActionEvent(
	    new ActionEvent(this, e.getID(), "\n" + nickname +" "+ ":" + " " + e.getActionCommand())
			      );
	}
    }

  
  class B5 implements ActionListener 
    {
      public void actionPerformed(ActionEvent e)
	{
	  f1.setVisible(true);
	  f2.setVisible(false);
	  nicknameField.setText("");
	}
    }  
  
  class B6 implements ActionListener
    {
      public void actionPerformed(ActionEvent e)
	{
	  typeMessagesField.dispatchEvent(
	    new ActionEvent(this, e.getID(), typeMessagesField.getText()));
	}
    }

  public static void main(String[] args){
    Chat ch = new Chat();
    Frame f = new Frame();
    f.setSize(500, 400);
    f.add(ch);
    f.setVisible(true);
  }
} 
