// for emacs only: -*- C++ -*-

// last modification 12/15/97

package examples.TSTP;

import java.io.*;
import EDU.rutgers.act.protocol.*;
import EDU.rutgers.CORBA.presentation.*;
import examples.TSTP.actions.*;
import examples.TSTP.messages.*;

class Server
{
  public static void main(String args[]) throws java.io.IOException
    {
      if(args.length != 1)
	{
	  System.out.println("usage: Server <portnumber>");
	  throw new IOException("Invalid arguments");
	}

      FSMDataFactory tstpSrvFactory =
	(FSMDataFactory)new TSTPServerDataFactory();
      MessageFactory msgFactory = 
	(MessageFactory)new TSTPMessageFactory();

      ProtocolServer protSrv =
	new ProtocolServer(tstpSrvFactory,
			   msgFactory,
			   new CDRTransferSyntaxFactory(),
			   Integer.parseInt(args[0]));

      while(true)
	{
	  Protocol protocol = protSrv.accept();

	  TSTPMessage request;

	  request = 
	    (TSTPMessage)protocol.getServerReceiver().receiveMessage();

	  while(request != null)
	    {
	      System.out.println("Received <"+request.getString()+">");
	      TSTPMessage answer = null;
	  
	      switch(request.getOpId())
		{
		case TSTPMessage.ECHO:
		  answer = new TSTPMessage(TSTPMessage.Reply,
					   TSTPMessage.ECHO,
					   request.getString(),
					   null);
		  break;
		case TSTPMessage.REVERT:
		  answer = new TSTPMessage(TSTPMessage.Reply,
					   TSTPMessage.ECHO,
					   Server.revert(request.getString()),
					   null);
		  break;
		case TSTPMessage.TOUPPER:
		  answer = new TSTPMessage(TSTPMessage.Reply,
					   TSTPMessage.ECHO,
					   request.getString().toUpperCase(),
					   null);
		  break;
		case TSTPMessage.TOLOWER:
		  answer = new TSTPMessage(TSTPMessage.Reply,
					   TSTPMessage.ECHO,
					   request.getString().toLowerCase(),
					   null);
		  break;
		default:
		  throw new IOException("Invalid Operation Id");
		}
	      if(protocol.getServerSender() == null)
		{
		  System.out.println("Null!");
		}
	  
	      protocol.getServerSender().sendMessage((Message)answer);
	      request = 
		(TSTPMessage)protocol.getServerReceiver().receiveMessage();
	    }
	}
    }

  static protected String revert(String inStr)
    {
      byte[] in = inStr.getBytes();
      byte[] out = new byte[in.length];
      for(int i = 0; i < in.length; i++)
	{
	  out[i] = in[in.length - i -1];
	}
      return new String(out);
    }
}
