// for emacs only: -*- C++ -*-

// last update: 09/23/97

import java.io.*;         // file input/output
import org.omg.CORBA.*;   // holder classes
import Testing.*;         // the idl interfaces

import EDU.rutgers.CORBA.clntsrv.PortableServer.POAPackage.*; // exceptions

class Server
{
  static final String FILE_NAME = "ior.txt";

  public static void main(String[] args) throws 
    IOException,
    ObjectNotActive,
    WrongPolicy
    {
      // initialize the ORB
      ORB orb = ORB.init(args, null);

      // create implementation
      _ArrayProcessorImpl servant = new _ArrayProcessorImpl();

      // register implementation
      orb.connect(servant);

      // get the object reference for this servant
      String stringifiedIOR = orb.object_to_string(servant);
      
      // write it to a file
      FileOutputStream file = new FileOutputStream(FILE_NAME);
      file.write(stringifiedIOR.getBytes());
      file.close();

      System.out.println("Created stringified IOR for this object:");
      System.out.println(stringifiedIOR);

      // wait for invocations from clients
      java.lang.Object sync = new java.lang.Object();
      try
	{
	  synchronized (sync) {
	    sync.wait();
	  }
	}
      catch (Exception ex) {
	System.err.println("ERROR: " + ex);
	ex.printStackTrace(System.out);
      }
    }
}
